

C***********************************
C***********************************
C***********************************
C	Make sure you set find_mwaits.inc to have the correct file format
C	monitor file you are looking at, the file format has changed over
C	the years.
C	If you are on a newer version of FORTRAN but using an old record
C	format then you MUST!!!! add in /ALIGNMENT=RECORD=PACKED or the
C	prgram will crash when run or will show 17-NOV-1858 as the start
C	date in the header.
C
C	FORTRAN /ALIGNMENT=(COMMONS=(PACKED),RECORDS=PACKED)/WARN=NOALIGN/LIST FIND_MWAITS
C
C***********************************
C***********************************
C***********************************
C***********************************

C*
	PROGRAM FIND_MWAITS
C*
C*	This program will read through a MONITOR/RECORD file and find any
C*	processes that are in requested state and report on that process.
C*	It also reports on any particular snapshot where the count of
C*	Computable processes meets or exceeds the "Magic Number" set with
C*	the /COUNT switch.
C*
C******************************************************************************
C*	The format for calling this program is
C*	MWAIT input_file_name
C*		/OUTPUT=output_file_name 		(/OUTPUT=SYS$OUTPUT)
C*		/[NO]COUNT=number			(/COUNT=4)
C*		/[NO]COLPG				(/COLPG)
C*		/[NO]MWAIT				(/MWAIT)
C*		/[NO]CEF				(/NOCEF)
C*		/[NO]PFW				(/NOPFW)
C*		/[NO]LEF				(/NOLEF)
C*		/[NO]LEFO				(/LEFO)
C*		/[NO]HIB				(/NOHIB)
C*		/[NO]HIBO				(/HIBO)
C*		/[NO]SUSP				(/SUSP)
C*		/[NO]SUSPO				(/SUSPO)
C*		/[NO]FPG				(/FPG)
C*		/[NO]COM				(/NOCOM)
C*		/[NO]COMO				(/COMO)
C*		/[NO]CUR				(/NOCUR)
C*		/[NO]SUMMARY				(/NOSUMMARY)
C*
C*****************************************************************************

	INCLUDE '($STSDEF)'
	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*16384	RECORD_STRING  ! The Process record can be over 8500

	CHARACTER*80	FILE_NAME,
	1		OUTNAME,
	2		DATE_OUT
	CHARACTER*25	RECORD_TEXT
	CHARACTER*5	COMPUTE_COUNT

	INTEGER*4	DATE_LEN
	INTEGER*2	LENGTH,
	1		OUTNAME_SIZE
	LOGICAL		THERE

	INTEGER		CLI$PRESENT,
	1		CLI$GET_VALUE
	EXTERNAL	CLI$_PRESENT,
	1		CLI$_DEFAULTED


C*
C*            Get the input file
C*
	ISTATUS = CLI$GET_VALUE ('INFILE',FILE_NAME)
	IF (.NOT. ISTATUS) CALL LIB$STOP (%VAL(ISTATUS))

C*
C*		Check to see of the file is there.
C*
	INQUIRE(FILE=FILE_NAME,EXIST=THERE)
	IF (.NOT.THERE) THEN
		TYPE 100, FILE_NAME
		GOTO 9999
	ENDIF
100	FORMAT('0NO SUCH FILE: ',A)

	IF ((CLI$PRESENT ('OUTPUT') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('OUTPUT') .EQ. %LOC(CLI$_DEFAULTED))) THEN

		ISTATUS = CLI$GET_VALUE('OUTPUT',OUTNAME,OUTNAME_SIZE)
		IF (.NOT. ISTATUS) CALL LIB$STOP(%VAL(ISTATUS))
	ENDIF

	OPEN(UNIT=20,
	1	FILE=OUTNAME(1:OUTNAME_SIZE),
	2	STATUS='NEW',
	3	FORM='FORMATTED')


	IF ((CLI$PRESENT ('COLPG') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('COLPG') .EQ. %LOC(CLI$_DEFAULTED))) COLPG = .TRUE.
	IF ((CLI$PRESENT ('MWAIT') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('MWAIT') .EQ. %LOC(CLI$_DEFAULTED))) MWAIT = .TRUE.
	IF ((CLI$PRESENT ('CEF') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('CEF') .EQ. %LOC(CLI$_DEFAULTED))) CEF = .TRUE.
	IF ((CLI$PRESENT ('PFW') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('PFW') .EQ. %LOC(CLI$_DEFAULTED))) PFW = .TRUE.
	IF ((CLI$PRESENT ('LEF') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('LEF') .EQ. %LOC(CLI$_DEFAULTED))) LEF = .TRUE.
	IF ((CLI$PRESENT ('LEFO') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('LEFO') .EQ. %LOC(CLI$_DEFAULTED))) LEFO = .TRUE.
	IF ((CLI$PRESENT ('HIB') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('HIB') .EQ. %LOC(CLI$_DEFAULTED))) HIB = .TRUE.
	IF ((CLI$PRESENT ('HIBO') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('HIBO') .EQ. %LOC(CLI$_DEFAULTED))) HIBO = .TRUE.
	IF ((CLI$PRESENT ('SUSP') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('SUSP') .EQ. %LOC(CLI$_DEFAULTED))) SUSP = .TRUE.
	IF ((CLI$PRESENT ('SUSPO') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('SUSPO') .EQ. %LOC(CLI$_DEFAULTED))) SUSPO = .TRUE.
	IF ((CLI$PRESENT ('FPG') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('FPG') .EQ. %LOC(CLI$_DEFAULTED))) FPG = .TRUE.
	IF ((CLI$PRESENT ('COM') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('COM') .EQ. %LOC(CLI$_DEFAULTED))) COM = .TRUE.
	IF ((CLI$PRESENT ('COMO') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('COMO') .EQ. %LOC(CLI$_DEFAULTED))) COMO = .TRUE.
	IF ((CLI$PRESENT ('CUR') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('CUR') .EQ. %LOC(CLI$_DEFAULTED))) CUR = .TRUE.
	IF ((CLI$PRESENT ('SUMMARY') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('SUMMARY') .EQ. %LOC(CLI$_DEFAULTED))) SUMMARY = .TRUE.

C*
C*	Check to see if the user wants to count the COMputable Processes.
C*	Otherwise set the minimum value to a high number that should
C*	never be exceeded.
C*
	IF ((CLI$PRESENT ('COUNT') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('COUNT') .EQ. %LOC(CLI$_DEFAULTED))) THEN
			ISTATUS = CLI$GET_VALUE('COUNT',COMPUTE_COUNT,LENGTH)
			IF (.NOT. ISTATUS) CALL LIB$STOP (%VAL(ISTATUS))
			DECODE (LENGTH,500,COMPUTE_COUNT(1:LENGTH))
	1			COMPUTE_COUNT_VALUE
	ELSE
		COMPUTE_COUNT_VALUE = 999
	ENDIF
500	FORMAT(I<LENGTH>)

C*
C*	Set the Line Counter so we will force a page break
C*
	LINE_COUNT = 99

C*
C*	Open the Monitor File, use SHARED just in case you are reading an
C*	active recording file.
C*
	OPEN (UNIT=10, FILE=FILE_NAME,STATUS='OLD',READONLY,SHARED)

10	READ (10,110,END=1000) LENGTH, RECORD_STRING
110	FORMAT (Q,A)
D	type * , 'length of record =', length

C*
C*	Extract the Record Type Field.
C*

	CALL COPY_STRING_TO_RECORD (RECORD_STRING,CLASS_HEADER_REC.OVERLAY
	1		,0,len(CLASS_HEADER_REC.overlay))

C*
C*	This block was removed since we are only dealing with one record type
C*	but if you want to modify this program to deal with the other
C*	records then you can uncomment this section and the FIND_RECORD_TEXT
C*	subroutine.
C*
C*******C*
C*******C*	Find out what type of record we are dealing with
C*******C*
C*******
C*******	CALL FIND_RECORD_TEXT (CLASS_HEADER_REC.MNR_CLS$B_TYPE,RECORD_TEXT)
C*******
C*******C*	For some reason we are getting record types 22 and 23, these are not
C*******C*	described in the documentation.
C*******D	IF (RECORD_TEXT .EQ. 'Unknown Record Type') TYPE *, RECORD_TEXT,
C*******D	1	CLASS_HEADER_REC.MNR_CLS$B_TYPE

D	type *, 'record type:', CLASS_HEADER_REC.MNR_CLS$B_TYPE

C*
C*	The Process Record and System Information Record are the only ones we
C*	are concerned with in this program.
C*
	IF (CLASS_HEADER_REC.MNR_CLS$B_TYPE .EQ. MNR_HDR$_TYPE)
	1	CALL FILE_HEADER_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	IF (CLASS_HEADER_REC.MNR_CLS$B_TYPE .EQ. MNR_SYI$_TYPE)
	1	CALL SYSTEM_INFO_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	IF (CLASS_HEADER_REC.MNR_CLS$B_TYPE .EQ. MNR_PRO$_TYPE)
	1	CALL PROCESS_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	GOTO 10

1000	IF (LINE_COUNT .EQ. 99) WRITE (20,200)

200	FORMAT('1','There were no records found to match the criteria.')

	CLOSE (UNIT=10)
	CLOSE (unit=20)
9999	END



C******************************************************************************
C*
C*	This subroutine simply copies one string to another. It is used
C*	to copy parts of the string we read in to the proper record format
C*
	SUBROUTINE COPY_STRING_TO_RECORD
	1	(INSTRING,OUTSTRING,START_POS,NUM_CHARS)

	CHARACTER*(*)	INSTRING
	CHARACTER*(*)	OUTSTRING
	INTEGER		START_POS,
	1	   	NUM_CHARS,
	2		I

	DO I = 1, NUM_CHARS
		OUTSTRING(I:I) = INSTRING(START_POS+I:START_POS+I)
	END DO

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine converts the Record Type Byte into a Text Description
C*
C******* NOTE:
C*******    This particular program does not use this routine, but it is
C*******    left here for future enhancements.
C*******
	SUBROUTINE FIND_RECORD_TEXT (RECORD_TYPE,RECORD_TEXT)

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	RECORD_TEXT
	BYTE		RECORD_TYPE

	RECORD_TEXT = 'Unknown Record Type'

	IF (RECORD_TYPE .EQ. MNR_HDR$_TYPE)
	1	RECORD_TEXT = 'Header Record'
	IF (RECORD_TYPE .EQ. MNR_SYI$_TYPE)
	1	RECORD_TEXT = 'System Information Record'
	IF (RECORD_TYPE .EQ. MNR_NTR$_TYPE)
	1	RECORD_TEXT = 'Node Trasition Record'
	IF (RECORD_TYPE .EQ. MNR_FIL$_TYPE)
	1	RECORD_TEXT = 'RMS File Record'
	IF (RECORD_TYPE .EQ. MNR_PRO$_TYPE)
	1	RECORD_TEXT = 'Process Record'
	IF (RECORD_TYPE .EQ. MNR_STA$_TYPE)
	1	RECORD_TEXT = 'States Record'
	IF (RECORD_TYPE .EQ. MNR_MOD$_TYPE)
	1	RECORD_TEXT = 'Modes Record'
	IF (RECORD_TYPE .EQ. MNR_PAG$_TYPE)
	1	RECORD_TEXT = 'Page Record'
	IF (RECORD_TYPE .EQ. MNR_IO$_TYPE)
	1	RECORD_TEXT = 'I/O Record'
	IF (RECORD_TYPE .EQ. MNR_FCP$_TYPE)
	1	RECORD_TEXT = 'FCP Record'
	IF (RECORD_TYPE .EQ. MNR_POO$_TYPE)
	1	RECORD_TEXT = 'Pool Record'
	IF (RECORD_TYPE .EQ. MNR_LCK$_TYPE)
	1	RECORD_TEXT = 'Lock Record'
	IF (RECORD_TYPE .EQ. MNR_NET$_TYPE)
	1	RECORD_TEXT = 'DECNET Record'
	IF (RECORD_TYPE .EQ. MNR_FLI$_TYPE)
	1	RECORD_TEXT = 'File System Cache Record'
	IF (RECORD_TYPE .EQ. MNR_DSK$_TYPE)
	1	RECORD_TEXT = 'Disk Record'
	IF (RECORD_TYPE .EQ. MNR_DLO$_TYPE)
	1	RECORD_TEXT = 'Dlock Record'
	IF (RECORD_TYPE .EQ. MNR_SCS$_TYPE)
	1	RECORD_TEXT = 'SCS Record'
	IF (RECORD_TYPE .EQ. MNR_SYS$_TYPE)
	1	RECORD_TEXT = 'System Record'
	IF (RECORD_TYPE .EQ. MNR_CLU$_TYPE)
	1	RECORD_TEXT = 'Cluster Record'
	IF (RECORD_TYPE .EQ. MNR_RMS$_TYPE)
	1	RECORD_TEXT = 'RMS Record'
	IF (RECORD_TYPE .EQ. MNR_MSC$_TYPE)
	1	RECORD_TEXT = 'MSCP Record'

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine performs the processing that we want when we hit
C*	a File Header Record (The File Header record should be the first
C*	record in the file in most cases.)
C*
	SUBROUTINE FILE_HEADER_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	RECORD_STRING

	CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		FILE_HEADER_REC.OVERLAY,0,
	2		len(file_header_rec.overlay))


	CALL LIB$FORMAT_DATE_TIME(BEGINNING_TEXT,
	1		FILE_HEADER_REC.MNR_HDR$Q_BEGINNING,,BEGINNING_LEN)
	CALL LIB$FORMAT_DATE_TIME(ENDING_TEXT,
	1		FILE_HEADER_REC.MNR_HDR$Q_ENDING,,ENDING_LEN)

	INTERVAL =  FILE_HEADER_REC.MNR_HDR$L_INTERVAL

	COMMENT = FILE_HEADER_REC.MNR_HDR$T_COMMENT
	COMMENT_LEN = FILE_HEADER_REC.MNR_HDR$W_COMLEN

C
C	Some versions of monitor create a comment that is filled with nulls
C	and the FILE_HEADER_REC.MNR_HDR$W_COMLEN includes all the nulls,
C	so let's find the first null and trucate the comment there.
C
	find_length: do size = 2, comment_len
		if (COMMENT(size:size) .eq. char(0)) exit find_length
		end do find_length
	if (size .lt. comment_len) comment_len = size - 1


	RETURN
	END

C******************************************************************************
C*
C*	This subroutine performs the processing that we want when we hit
C*	a System Information Record (The system information record
C*	should be the second record in the file in most cases.)
C*
	SUBROUTINE SYSTEM_INFO_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	RECORD_STRING

	CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		SYSTEM_INFO_REC.OVERLAY,0,
	2		len(SYSTEM_INFO_REC.OVERLAY))

	NODE_LENGTH = ICHAR(SYSTEM_INFO_REC.MNR_SYI$T_NODENAME(1:1))
	NODE = SYSTEM_INFO_REC.MNR_SYI$T_NODENAME(2:NODE_LENGTH+1)

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine performs the processing that we want when we hit
C*	a PROCESS RECORD.
C*
	SUBROUTINE PROCESS_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	INCLUDE '($LIBDTDEF)'
	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	RECORD_STRING
	CHARACTER*80	DATE_OUT
	INTEGER*4	DATE_LEN,
	1		COMPUTABLE,
	2		BATCH_COUNT,
	3		INTER_COUNT,
	4		NETWORK_COUNT,
	5		OTHER_COUNT

	CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		CLASS_PREFIX_REC.OVERLAY,
	2		len(CLASS_HEADER_REC.overlay),
	3		len(CLASS_PREFIX_REC.overlay))

C*
C*	Get the date/time that the record was created
C*
	CALL LIB$FORMAT_DATE_TIME(DATE_OUT,
	1		CLASS_HEADER_REC.MNR_CLS$Q_STAMP,,TIME_LEN,
	2		LIB$M_TIME_FIELDS)

D	WRITE (20, 200) DATE_OUT,CLASS_PREFIX_REC.MNR_CMP$L_ELTCT

200	FORMAT (1X,A<TIME_LEN>,X,'THERE ARE ',I3,
	1		' PROCESSES IN THIS RECORD')

C*
C*	Loop through each of the processes held in this record.
C*

	DO I = 1, CLASS_PREFIX_REC.MNR_CMP$L_ELTCT
		CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		PROCESS_REC.OVERLAY,
	2		len(CLASS_PREFIX_REC.overlay)+			!  8   8
	3		len(class_header_rec.overlay)+((I-1)*		! 13  16
	4		len(process_rec.overlay)),			! 67  72
	5		len(process_rec.overlay))

C*
C*	Check to see if the Process State is one that we are interested in
C*
		CALL CHECK_STATE (DATE_OUT,DATE_LEN,
	1		ICHAR(PROCESS_REC.MNR_PRO$T_LNAME(1:1)),
	2		PROCESS_REC.MNR_PRO$T_LNAME(2:),
	3		PROCESS_REC.MNR_PRO$W_STATE,
	4		PROCESS_REC.MNR_PRO$L_EFWM,
	5		PROCESS_REC.MNR_PRO$W_UIC_GRP,
	6		PROCESS_REC.MNR_PRO$W_UIC_MEM,
	7		PROCESS_REC.MNR_PRO$L_EPID,
	8		PROCESS_REC.MNR_PRO$L_STS,
	9		CLASS_PREFIX_REC.MNR_CMP$L_ELTCT,
	1		COMPUTABLE,
	2		BATCH_COUNT,
	3		INTER_COUNT,
	4		NETWORK_COUNT,
	5		OTHER_COUNT)
	END DO

C*
C*	Report if there are too many COM (including COMO) processes (unless
C*	we still have to read in another record to complete this snapshot).
C*
	IF (.NOT. (CLASS_HEADER_REC.MNR_CLS$B_FLAGS .AND. 1)) THEN

		IF (COMPUTABLE .GE. COMPUTE_COUNT_VALUE) THEN
			IF (LINE_COUNT .GT. 55) CALL PRINT_HEADINGS
			LINE_COUNT = LINE_COUNT + 1
			WRITE (20,250) DATE_OUT,
	1			COMPUTABLE,
	2			CLASS_PREFIX_REC.MNR_CMP$L_ELTCT
		ENDIF

		IF (SUMMARY) THEN
			IF (LINE_COUNT .GT. 55) CALL PRINT_HEADINGS
			LINE_COUNT = LINE_COUNT + 1
			WRITE (20,260) DATE_OUT,
	1			INTER_COUNT,
	2			BATCH_COUNT,
	3			NETWORK_COUNT,
	4			OTHER_COUNT,
	5			CLASS_PREFIX_REC.MNR_CMP$L_ELTCT
		ENDIF

		COMPUTABLE = 0
		BATCH_COUNT = 0
		INTER_COUNT = 0
		NETWORK_COUNT = 0
		OTHER_COUNT = 0

	ENDIF

D	IF (CLASS_HEADER_REC.MNR_CLS$B_FLAGS .AND. 1) type *,
D	1	'Continuation record'

250	FORMAT(1X,A<TIME_LEN>,39X,I3,X,
	1	'Computable processes.',15X,I5)

260	FORMAT(1X,A<TIME_LEN>,15X,'Interactive: ',I5, ' Batch: ', I5,
	1	' Network: ', I5, ' Other: ', I5,5X,I5)

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine checks to see if the process is in a state
C*	that we want to look at.
C*
	SUBROUTINE CHECK_STATE (DATE_OUT,DATE_LEN,
	1	NUM_CHARS,PROCESS_NAME,PROCESS_STATE,EVENT_FLAG,
	2	UIC_GRP,UIC_MEM,PROCESS_ID,PROCESS_STS,
	3	TOTAL_PROCESS,COMPUTABLE,
	4	BATCH_COUNT,INTER_COUNT,NETWORK_COUNT,OTHER_COUNT)

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	DATE_OUT
	CHARACTER*(*)	PROCESS_NAME

	CHARACTER*40	TEXT_STRING

	INTEGER*4	DATE_LEN,
	1		EVENT_FLAG,
	2		COMPUTABLE,
	3		NUM_CHARS,
	4		PROCESS_ID,
	5		PROCESS_STS,
	6		TOTAL_PROCESS,
	7		BATCH_COUNT,
	8		INTER_COUNT,
	9		NETWORK_COUNT,
	1		OTHER_COUNT

	INTEGER*2	PROCESS_STATE,
	1		UIC_GRP,
	2		UIC_MEM


	TEXT_STRING = ' '

C*
C*	Check to see if this process is one that we want to report on.
C*
	IF ((COLPG) .AND. (PROCESS_STATE .EQ. SCH$C_COLPG))
	1	TEXT_STRING = SCH$T_COLPG
	IF ((CEF) .AND. (PROCESS_STATE .EQ. SCH$C_CEF))
	1	TEXT_STRING = SCH$T_CEF
	IF ((PFW) .AND. (PROCESS_STATE .EQ. SCH$C_PFW))
	1	TEXT_STRING = SCH$T_PFW
	IF ((LEF) .AND. (PROCESS_STATE .EQ. SCH$C_LEF))
	1	TEXT_STRING = SCH$T_LEF
	IF ((LEFO) .AND. (PROCESS_STATE .EQ. SCH$C_LEFO))
	1	TEXT_STRING = SCH$T_LEFO
	IF ((HIB) .AND. (PROCESS_STATE .EQ. SCH$C_HIB))
	1	TEXT_STRING = SCH$T_HIB
	IF ((HIBO) .AND. (PROCESS_STATE .EQ. SCH$C_HIBO))
	1	TEXT_STRING = SCH$T_HIBO
	IF ((SUSP) .AND. (PROCESS_STATE .EQ. SCH$C_SUSP))
	1	TEXT_STRING = SCH$T_SUSP
	IF ((SUSPO) .AND. (PROCESS_STATE .EQ. SCH$C_SUSPO))
	1	TEXT_STRING = SCH$T_SUSPO
	IF ((FPG) .AND. (PROCESS_STATE .EQ. SCH$C_FPG))
	1	TEXT_STRING = SCH$T_FPG
	IF ((COM) .AND. (PROCESS_STATE .EQ. SCH$C_COM))
	1	TEXT_STRING = SCH$T_COM
	IF ((COMO) .AND. (PROCESS_STATE .EQ. SCH$C_COMO))
	1	TEXT_STRING = SCH$T_COMO
	IF ((CUR) .AND. (PROCESS_STATE .EQ. SCH$C_CUR))
	1	TEXT_STRING = SCH$T_CUR

C*
C*	Keep track of the number of Computable (or Computable-Outswapped)
C*	processes so we can report if there are too many.
C*
	IF ((PROCESS_STATE .EQ. SCH$C_COM) .OR.
	1	(PROCESS_STATE .EQ. SCH$C_COMO)) COMPUTABLE = COMPUTABLE + 1

	IF ((PROCESS_STS .AND. PCB$M_BATCH) .EQ. PCB$M_BATCH) THEN
		BATCH_COUNT = BATCH_COUNT + 1
	ELSE
		IF ((PROCESS_STS .AND. PCB$M_INTER) .EQ. PCB$M_INTER) THEN
			INTER_COUNT = INTER_COUNT + 1
		ELSE
			IF ((PROCESS_STS .AND. PCB$M_NETWRK) .EQ. PCB$M_NETWRK) THEN
				NETWORK_COUNT = NETWORK_COUNT + 1
			ELSE
				OTHER_COUNT = OTHER_COUNT + 1
			ENDIF
		ENDIF
	ENDIF

C*
C*	If the process is in a MWAIT then find out which one.
C*
	IF (MWAIT .AND. (PROCESS_STATE .EQ. SCH$C_MWAIT)) THEN
		CALL CONVERT_MWAIT_TEXT (EVENT_FLAG,TEXT_STRING)
	END IF



C*
C*	If this is a process that we want to report on then we will
C*	write it out.
C*
	IF (TEXT_STRING .NE. ' ') THEN
		IF (LINE_COUNT .GT. 55) CALL PRINT_HEADINGS
		LINE_COUNT = LINE_COUNT + 1
		if (num_chars .gt. 16) then
			process_name = 'UNKNOWN'
			num_chars = 7
		end if
		WRITE (20,300,iostat=istatus) DATE_OUT,UIC_GRP,UIC_MEM,
	1		PROCESS_ID,PROCESS_NAME(1:NUM_CHARS),
	2		TEXT_STRING,TOTAL_PROCESS
		if (istatus .ne. 0 .and. istatus .ne. 63) then
			type *, 'write returned', istatus
			call lib$signal(%val(4))
		endif
	ENDIF


300	FORMAT (1X,A<TIME_LEN>,X,'[',O4.4,',',O4.4,']',X,Z8.8,X,
	1		A<NUM_CHARS>,<16-NUM_CHARS>X,X,A40,X,I4)

	RETURN
	END


C******************************************************************************
C*
C*	This subroutine prints out the headings at the top of the page
C*
	SUBROUTINE PRINT_HEADINGS

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*80	DATE_OUT
	INTEGER*4	DATE_LEN

C*
C*	Get the current date/time
C*
	CALL LIB$FORMAT_DATE_TIME(DATE_OUT,,,DATE_LEN)
C*
C*	Write out our Heading
C*
	WRITE (20,100)
	WRITE (20,110) NODE, BEGINNING_TEXT,ENDING_TEXT,INTERVAL
	WRITE (20,120) DATE_OUT
	IF (COMMENT_LEN .NE. 0) THEN
		WRITE (20,125) COMMENT(1:comment_len)
		LINE_COUNT = 6
	ELSE
		LINE_COUNT = 5
	ENDIF
	WRITE (20,130)
	WRITE (20,140)

100	FORMAT('1',54X,'Processes State Summary')
110	FORMAT(1X,<48-((NODE_LENGTH+BEGINNING_LEN+ENDING_LEN)/2)>X,
	1	'On',X,A<NODE_LENGTH>,
	2	X,'from',X,A<BEGINNING_LEN>,X,'to',
	3	X,A<ENDING_LEN>,X,'(',I3,X,'Second Interval)')
120	FORMAT(1X,<(122-DATE_LEN)/2>X,'Run Date:',X,A<DATE_LEN>)
125	FORMAT(1X,<66-(COMMENT_LEN/2)>X,A<COMMENT_LEN>)
130	FORMAT (1X)
140	FORMAT (1X,'Time',<TIME_LEN-5>X,6X,'UIC',7X,'PID',4X,
	1	'Process Name',5X,'State',35X,'Total')

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine converts the Integer value of the Event Flag
C*	into the text description of the MWAIT.
C*
	SUBROUTINE CONVERT_MWAIT_TEXT (EVENT_FLAG,MWAIT_TEXT)

	INCLUDE	'FIND_MWAITS.INC'

	CHARACTER*(*)	MWAIT_TEXT
	INTEGER*4	EVENT_FLAG

	MWAIT_TEXT = 'MUTEX - Mutual Exclusive Semaphore'

	IF (EVENT_FLAG .EQ. RSN$_ASTWAIT) MWAIT_TEXT = RSN$T_ASTWAIT
	IF (EVENT_FLAG .EQ. RSN$_MAILBOX) MWAIT_TEXT = RSN$T_MAILBOX
	IF (EVENT_FLAG .EQ. RSN$_NPDYNMEM) MWAIT_TEXT = RSN$T_NPDYNMEM
	IF (EVENT_FLAG .EQ. RSN$_PGFILE) MWAIT_TEXT = RSN$T_PGFILE
	IF (EVENT_FLAG .EQ. RSN$_PGDYNMEM) MWAIT_TEXT = RSN$T_PGDYNMEM
	IF (EVENT_FLAG .EQ. RSN$_BRKTHRU) MWAIT_TEXT = RSN$T_BRKTHRU
	IF (EVENT_FLAG .EQ. RSN$_IACLOCK) MWAIT_TEXT = RSN$T_IACLOCK
	IF (EVENT_FLAG .EQ. RSN$_JQUOTA) MWAIT_TEXT = RSN$T_JQUOTA
	IF (EVENT_FLAG .EQ. RSN$_LOCKID) MWAIT_TEXT = RSN$T_LOCKID
	IF (EVENT_FLAG .EQ. RSN$_SWPFILE) MWAIT_TEXT = RSN$T_SWPFILE
	IF (EVENT_FLAG .EQ. RSN$_MPLEMPTY) MWAIT_TEXT = RSN$T_MPLEMPTY
	IF (EVENT_FLAG .EQ. RSN$_MPWBUSY) MWAIT_TEXT = RSN$T_MPWBUSY
	IF (EVENT_FLAG .EQ. RSN$_SCS) MWAIT_TEXT = RSN$T_SCS
	IF (EVENT_FLAG .EQ. RSN$_CLUSTRAN) MWAIT_TEXT = RSN$T_CLUSTRAN
	IF (EVENT_FLAG .EQ. RSN$_CPUCAP) MWAIT_TEXT = RSN$T_CPUCAP
	IF (EVENT_FLAG .EQ. RSN$_CLUSRV) MWAIT_TEXT = RSN$T_CLUSRV


	RETURN
	END

